Ticket #3 (closed defect: fixed)

Opened 7 years ago

Last modified 7 years ago

cause unhandled runtime exception if JFace application compiled via dmd

Reported by: yidabu Assigned to: keinfarbton
Priority: major Milestone: milestone4
Component: component1 Version: 1.0
Keywords: jface Cc: yidabu@gmail.com

Description

too slowly to build JFace application via dsss, but cause unhandled runtime exception if compiled via dmd:

compile command: dmd test.d -L/SUBSYSTEM:windows:5 -L/rc:dwt.res -release

unhanded runtime exception:

tango.core.Exception.IllegalElementException?: Attempt to include invalid key _in Collection

example code:

import  
    dwt.widgets.Display,
    dwt.widgets.Shell,
    dwt.DWT,
    dwt.widgets.Control,
    dwt.widgets.Composite,
    dwt.widgets.Label,
    dwtx.jface.window.ApplicationWindow;
    
debug import    tango.util.log.Trace;    

public class MyWindow : ApplicationWindow
{    
    this()
    {
        addMenuBar;
        super(null);
    }
    void run()
    {        
        setBlockOnOpen(true);
        open();
        Display.getCurrent.dispose;
    }
    
    protected Control createContents(Composite parent)
    {
        auto label = new Label(parent, DWT.CENTER);
        label.setText("hello");
        return label;
    }
    
}

void main(char[][] args)
{
    (new MyWindow).run;
        
} 

Change History

(follow-up: ↓ 2 ) 05/16/08 13:14:20 changed by hduregger

I have a similar problem.

So far I've just included the source of all libraries that I need with my projects and compiled the application with dsss. This runs and compiles fine. But unfortunately dwt takes too long to build every time.

That's why I've tried to create a library from the dwt and dwtx sources with dsss. They compile fine too, but the application compile-time-linked to those libraries fails with the same exception that is mentioned above by yidabu.

I don't have a clue what is going on. But maybe this info can help fix the problem. Thanks for dwt!

(in reply to: ↑ 1 ) 05/16/08 13:33:37 changed by hduregger

Other stumbling upon this problem can also check out the newsgroups entry at http://www.digitalmars.com/webnews/newsgroups.php?art_group=digitalmars.D.dwt&article_id=1109

No workaround/fix yet though.

05/16/08 19:47:54 changed by keinfarbton

can you create a stacktrace? (ddbg)

05/16/08 23:18:05 changed by yidabu

if compiling with -g, cause compile time error:

phobos.lib
 Warning 2: File Not Found phobos.lib
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D9invariant12_d_invariantFC6ObjectZv
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined __d_newclass
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _main
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined __acrtused_con
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D10ModuleInfo6__vtblZ
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D6object6Object8opEqualsMFC6ObjectZi
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D6object6Object5opCmpMFC6ObjectZi
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D6object6Object6toHashMFZk
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D6object6Object8toStringMFZAa
DwtTest.obj(DwtTest) 
 Error 42: Symbol Undefined _D9ClassInfo6__vtblZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __except_list
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_dynamic_cast
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D6Object7__ClassZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_framehandler
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_local_unwind2
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_throw@4
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_newarrayT
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D11TypeInfo_Ab6__initZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __d_interface_cast
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __d_criticalenter
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __d_criticalexit
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __d_arrayappendT
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __d_callfinalizer
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D11TypeInfo_Aa6__initZ
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __d_arraycatnT
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D5tango4core9Exception22NoSuchElementException5_ctorMFAaZC5tango4core9Exception22NoSuchElementException
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D5tango4core9Exception23IllegalElementException7__ClassZ
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D5tango4core9Exception23IllegalElementException5_ctorMFAaZC5tango4core9Exception23IllegalElementException
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined __adDupT
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D5tango4core9Exception22NoSuchElementException7__ClassZ
\tango\lib\dwtx.lib(Window) 
 Error 42: Symbol Undefined _D9Exception7__ClassZ
\tango\lib\dwtx.lib(ModalContext) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread5_ctorMFDFZvkZC5tango4core6Thread6Thread
\tango\lib\dwtx.lib(ModalContext) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread7getThisFZC5tango4core6Thread6Thread
\tango\lib\dwtx.lib(ModalContext) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread4joinMFbZv
\tango\lib\dwtx.lib(ModalContext) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread5startMFZv
\tango\lib\dwtx.lib(ModalContext) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread7__ClassZ
\tango\lib\dwtx.lib(CoolBarManager) 
 Error 42: Symbol Undefined _D6object9Exception5_ctorMFAaC9ExceptionZC9Exception
\tango\lib\dwtx.lib(CoolBarManager) 
 Error 42: Symbol Undefined _D11TypeInfo_Ai6__initZ
\tango\lib\dwtx.lib(CoolBarManager) 
 Error 42: Symbol Undefined __d_arrayliteralT
\tango\lib\dwtx.lib(CoolBarManager) 
 Error 42: Symbol Undefined __d_arraysetlengthT
\tango\lib\dwtx.lib(JFaceResources) 
 Error 42: Symbol Undefined __fltused
\tango\lib\dwtx.lib(JFaceResources) 
 Error 42: Symbol Undefined _D5tango4core9Exception24IllegalArgumentException7__ClassZ
\tango\lib\dwtx.lib(JFaceResources) 
 Error 42: Symbol Undefined _D5tango4core9Exception24IllegalArgumentException5_ctorMFAaZC5tango4core9Exception24IllegalArgumentException
\tango\lib\dwtx.lib(JFaceResources) 
 Error 42: Symbol Undefined _D14TypeInfo_Array6__vtblZ
\tango\lib\dwtx.lib(JFaceResources) 
 Error 42: Symbol Undefined _D14TypeInfo_Class6__vtblZ
\tango\lib\dwtx.lib(MenuManager) 
 Error 42: Symbol Undefined __d_arraycatT
\tango\lib\dwtx.lib(Category) 
 Error 42: Symbol Undefined _D14TypeInfo_Tuple6__vtblZ
\tango\lib\dwtx.lib(Category) 
 Error 42: Symbol Undefined _D18TypeInfo_Interface6__vtblZ
\tango\lib\dwtx.lib(Category) 
 Error 42: Symbol Undefined _D5tango4core9Exception26CorruptedIteratorException7__ClassZ
\tango\lib\dwtx.lib(Category) 
 Error 42: Symbol Undefined _D5tango4core9Exception26CorruptedIteratorException5_ctorMFAaZC5tango4core9Exception26CorruptedIteratorException
\tango\lib\dwtx.lib(Category) 
 Error 42: Symbol Undefined _D10TypeInfo_b6__initZ
\tango\lib\dwtx.lib(AccumulatingProgressMonitor) 
 Error 42: Symbol Undefined __d_monitor_prolog
\tango\lib\dwtx.lib(AccumulatingProgressMonitor) 
 Error 42: Symbol Undefined __d_monitor_epilog
\tango\lib\dwtx.lib(AccumulatingProgressMonitor) 
 Error 42: Symbol Undefined __d_monitor_handler
\tango\lib\dwtx.lib(AccumulatingProgressMonitor) 
 Error 42: Symbol Undefined __d_monitorenter
\tango\lib\dwtx.lib(AccumulatingProgressMonitor) 
 Error 42: Symbol Undefined __d_monitorexit
\tango\lib\dwtx.lib(OperationCanceledException) 
 Error 42: Symbol Undefined _D6object9Exception8toStringMFZAa
\tango\lib\dwtx.lib(Policy) 
 Error 42: Symbol Undefined _D10TypeInfo_a6__initZ
\tango\lib\dwtx.lib(Policy) 
 Error 42: Symbol Undefined __adCmp
\tango\lib\dwtx.lib(Policy) 
 Error 42: Symbol Undefined _D10TypeInfo_k6__initZ
\tango\lib\dwtx.lib(FontRegistry) 
 Error 42: Symbol Undefined __adEq
\tango\lib\dwtx.lib(FontRegistry) 
 Error 42: Symbol Undefined _D10TypeInfo_C6__initZ
\tango\lib\dwtx.lib(ActionContributionItem) 
 Error 42: Symbol Undefined _D10TypeInfo_l6__initZ
\tango\lib\dwtx.lib(CoreException) 
 Error 42: Symbol Undefined _D10TypeInfo_i6__initZ
\tango\lib\dwtx.lib(Dialog) 
 Error 42: Symbol Undefined __aaGet
\tango\lib\dwtx.lib(Dialog) 
 Error 42: Symbol Undefined __aaIn
\tango\lib\dwtx.lib(ColumnViewer) 
 Error 42: Symbol Undefined __d_arrayappendcT
\tango\lib\dwtx.lib(ContentProposalAdapter) 
 Error 42: Symbol Undefined _D5tango4core6Thread6Thread5sleepFdZv
\tango\lib\dwtx.lib(ContentProposalAdapter) 
 Error 42: Symbol Undefined _D10TypeInfo_u6__initZ
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D16TypeInfo_Pointer6__vtblZ
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D15TypeInfo_Struct6__vtblZ
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D5tango4core9Exception12XmlException7__ClassZ
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D5tango4core9Exception12XmlException5_ctorMFAaZC5tango4core9Exception12XmlException
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D5tango4core9Exception13TextException7__ClassZ
\tango\lib\dwtx.lib(DialogSettings) 
 Error 42: Symbol Undefined _D5tango4core9Exception11IOException7__ClassZ
\tango\lib\dwtx.lib(FileImageDescriptor) 
 Error 42: Symbol Undefined _D10TypeInfo_v6__initZ
\tango\lib\dwtx.lib(LayoutGenerator) 
 Error 42: Symbol Undefined _D9ClassInfo7__ClassZ
\tango\lib\dwt.lib(Display) 
 Error 42: Symbol Undefined _D11TypeInfo_Ah6__initZ
\tango\lib\dwt.lib(Label) 
 Error 42: Symbol Undefined _D11TypeInfo_Au6__initZ
\tango\lib\dwt.lib(Label) 
 Error 42: Symbol Undefined __d_newarrayiT
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined _memmove
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined __ULDIV@
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined __d_arraysetlengthiT
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined _D11TypeInfo_Aw6__initZ
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined __memset32
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined _D10TypeInfo_w6__initZ
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined _exit
\tango\lib\dwt.lib(GridLayout) 
 Error 42: Symbol Undefined __d_newarraymT
\tango\lib\dwt.lib(utils) 
 Error 42: Symbol Undefined _gc_stats
\tango\lib\dwt.lib(Composite) 
 Error 42: Symbol Undefined _D10TypeInfo_f6__initZ
\tango\lib\dwt.lib(ResourceBundle) 
 Error 42: Symbol Undefined __aaKeys
\tango\lib\dwt.lib(Display) 
 Error 42: Symbol Undefined _D11TypeInfo_Ag6__initZ
\tango\lib\dwt.lib(System) 
 Error 42: Symbol Undefined __LDIV@
\tango\lib\dwt.lib(CLabel) 
 Error 42: Symbol Undefined _D20TypeInfo_StaticArray6__vtblZ
\tango\lib\dwt.lib(WeakHashMap) 
 Error 42: Symbol Undefined __aaDel
\tango\lib\dwt.lib(GC) 
 Error 42: Symbol Undefined _D11TypeInfo_Ak6__initZ
\tango\lib\dwt.lib(GC) 
 Error 42: Symbol Undefined _D11TypeInfo_Af6__initZ
\tango\lib\dwt.lib(GC) 
 Error 42: Symbol Undefined __d_arraycast
\tango\lib\dwt.lib(XmlTranscode) 
 Error 42: Symbol Undefined __d_switch_string
\tango\lib\dwt.lib(XmlTranscode) 
 Error 42: Symbol Undefined _D5tango4core9Exception13TextException5_ctorMFAaZC5tango4core9Exception13TextException
\tango\lib\dwt.lib(XmlTranscode) 
 Error 42: Symbol Undefined __aApplycd1
\tango\lib\dwt.lib(BufferedInputStream) 
 Error 42: Symbol Undefined _D5tango4core9Exception11IOException5_ctorMFAaZC5tango4core9Exception11IOException
\tango\lib\dwt.lib(Synchronizer) 
 Error 42: Symbol Undefined _D5tango4core9Exception13SyncException7__ClassZ
\tango\lib\dwt.lib(StyledText) 
 Error 42: Symbol Undefined __aaValues
\tango\lib\dwt.lib(DWTError) 
 Error 42: Symbol Undefined _D5tango4core9Exception17PlatformException7__ClassZ
\tango\lib\dwt.lib(DWTError) 
 Error 42: Symbol Undefined _D5tango4core9Exception17PlatformException5_ctorMFAaZC5tango4core9Exception17PlatformException
\tango\lib\dwt.lib(ToolTip) 
 Error 42: Symbol Undefined _Shell_NotifyIconW@8
\tango\lib\dwt.lib(Gdip) 
 Error 42: Symbol Undefined __d_delmemory
\tango\lib\dwt.lib(Accessible) 
 Error 42: Symbol Undefined _D10TypeInfo_h6__initZ
\tango\lib\dwt.lib(Compatibility) 
 Error 42: Symbol Undefined __d_delarray
\tango\lib\dwt.lib(BidiUtil) 
 Error 42: Symbol Undefined _D10TypeInfo_P6__initZ
\tango\lib\dwt.lib(OleAutomation) 
 Error 42: Symbol Undefined __adReverse
\tango\lib\dwt.lib(JPEGDecoder) 
 Error 42: Symbol Undefined _D11TypeInfo_As6__initZ
\tango\lib\dwt.lib(Variant) 
 Error 42: Symbol Undefined __memset16
\tango\lib\dwt.lib(Variant) 
 Error 42: Symbol Undefined __memset64
\tango\lib\dwt.lib(GIFFileFormat) 
 Error 42: Symbol Undefined _D10TypeInfo_g6__initZ
\tango\lib\dwt.lib(LEDataInputStream) 
 Error 42: Symbol Undefined _D5tango4core9Exception20ArrayBoundsException7__ClassZ
\tango\lib\dwt.lib(LEDataInputStream) 
 Error 42: Symbol Undefined _D5tango4core9Exception20ArrayBoundsException5_ctorMFAakZC5tango4core9Exception20ArrayBoundsException
\tango\lib\tango-user-dmd.lib(RegexIterator) 
 Error 42: Symbol Undefined _D13TypeInfo_Enum6__vtblZ
\tango\lib\tango-user-dmd.lib(FormatStream) 
 Error 42: Symbol Undefined _log10l
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined _D20TypeInfo_StaticArray7__ClassZ
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined _D25TypeInfo_AssociativeArray7__ClassZ
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined __aaApply
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined _D15TypeInfo_Struct7__ClassZ
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined _D13TypeInfo_Enum7__ClassZ
\tango\lib\tango-user-dmd.lib(Stdout) 
 Error 42: Symbol Undefined _D16TypeInfo_Typedef7__ClassZ
\tango\lib\tango-user-dmd.lib(Conduit) 
 Error 42: Symbol Undefined _D11TypeInfo_Av6__initZ
\tango\lib\tango-user-dmd.lib(Math) 
 Error 42: Symbol Undefined _roundl
\tango\lib\tango-user-dmd.lib(Math) 
 Error 42: Symbol Undefined _ceill
\tango\lib\tango-user-dmd.lib(Utf) 
 Error 42: Symbol Undefined _onUnicodeError
\tango\lib\tango-user-dmd.lib(UnicodeData) 
 Error 42: Symbol Undefined __aaRehash
\tango\lib\tango-user-dmd.lib(SharedLib) 
 Error 42: Symbol Undefined __d_delclass
\tango\lib\tango-user-dmd.lib(Mutex) 
 Error 42: Symbol Undefined _D6Object7Monitor11__InterfaceZ
\tango\lib\tango-user-dmd.lib(Condition) 
 Error 42: Symbol Undefined __DBLULNG@
\tango\lib\tango-user-dmd.lib(Condition) 
 Error 42: Symbol Undefined _D5tango4core9Exception13SyncException5_ctorMFAaZC5tango4core9Exception13SyncException
\tango\lib\tango-user-dmd.lib(Regex) 
 Error 42: Symbol Undefined __adSort
\tango\lib\tango-user-dmd.lib(Regex) 
 Error 42: Symbol Undefined __aaGetRvalue
\tango\lib\tango-user-dmd.lib(Regex) 
 Error 42: Symbol Undefined __aaApply2
\tango\lib\tango-user-dmd.lib(Arguments) 
 Error 42: Symbol Undefined _D17TypeInfo_Delegate6__vtblZ
\tango\lib\tango-user-dmd.lib(Arguments) 
 Error 42: Symbol Undefined __aaLen
\tango\lib\tango-user-dmd.lib(Log) 
 Error 42: Symbol Undefined __U64_LDBL
\tango\lib\tango-user-dmd.lib(Log) 
 Error 42: Symbol Undefined _memcmp
\tango\lib\tango-user-dmd.lib(Buffer) 
 Error 42: Symbol Undefined _memcpy
\tango\lib\tango-user-dmd.lib(Path) 
 Error 42: Symbol Undefined _wcslen
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined __nullext
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango4util3log6Config12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango4math4IEEE12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt3ole5win3214OleControlSite12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8internal3ole5win326EXDISP12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8internal3ole5win328MSHTMHST12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8internal3ole5win326COMAPI12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt9dwthelper4File12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt6layout10FormLayout12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango3sys7Process12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt13accessibility19AccessibleTextEvent12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8graphics12GlyphMetrics12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt7widgets5Caret12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt6custom26StyledTextDropTargetEffect12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt6custom16CTabFolderLayout12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8graphics4Path12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8graphics7Pattern12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D3dwt8graphics9Transform12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango2io8TempFile12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7viewers20ICellEditorValidator12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands18IHandlerAttributes12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface6wizard16IWizardContainer12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7viewers19SWTFocusCellManager12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface6wizard12WizardDialog12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8internal7runtime17IRuntimeConstants12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface8contexts11IContextIds12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango4text6locale4Core12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface10preference16IPreferenceStore12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface5menus13IMenuStateIds12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core7runtime10IAdaptable12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands10operations19ICompositeOperation12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands12HandlerEvent12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface11fieldassist24IContentProposalProvider12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface11fieldassist22IControlContentAdapter12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7viewers25LabelProviderChangedEvent12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7viewers13ICellModifier12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface8resource18URLImageDescriptor12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface8resource24ImageDataImageDescriptor12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango3net3Uri12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface10preference16JFacePreferences12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands10IParameter12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands22SerializationException12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx4core8commands31AbstractParameterValueConverter12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7dialogs15AnimatorFactory12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7dialogs20ErrorSupportProvider12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface7dialogs15TitleAreaDialog12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface10preference16PreferenceDialog12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D5tango4core6Thread12__ModuleInfoZ
\tango\lib\dwtx.lib(ApplicationWindow) 
 Error 42: Symbol Undefined _D4dwtx5jface9operation21IRunnableWithProgress12__ModuleInfoZ
OPTLINK : Warning 134: No Start Address 
--- errorlevel 193

05/16/08 23:26:45 changed by keinfarbton

I would expect that to be a build problem that can be solved by deleting all existing .obj and build libs and do a real rebuild.

05/16/08 23:27:49 changed by keinfarbton

Oh, why is it looking for phobos?

phobos.lib
 Warning 2: File Not Found phobos.lib

05/17/08 04:13:55 changed by yidabu

all existing .obj deleted, get same result.

05/18/08 23:37:59 changed by keinfarbton

Above the linker was not given the right libs, to link with tango (it was looking for phobos.lib and at the same time missing all tango symbols).

Did you solve your build error?
Does the problem still exist?

05/19/08 00:00:36 changed by keinfarbton

Again i tried the ActionAndStatusBar? example. I can build it without problems and i successfully run it on win2k and winXP.

I also tried your code from above. Again no problem.

05/19/08 07:29:16 changed by yidabu

bove the linker was not given the right libs, to link with tango

added dmd\lib to dmd\bin\sc.ini, it's build ok.

cause run time exception to build the code above, this is the ddbg output:

->r
No symbols available from ntdll.dll
ntdll.dll loaded at 0x7c900000
No symbols available from KERNEL32.dll
KERNEL32.dll loaded at 0x7c800000
No symbols available from USER32.dll
USER32.dll loaded at 0x7e410000
No symbols available from GDI32.dll
GDI32.dll loaded at 0x77f10000
No symbols available from ADVAPI32.dll
ADVAPI32.dll loaded at 0x77dd0000
No symbols available from RPCRT4.dll
RPCRT4.dll loaded at 0x77e70000
No symbols available from Secur32.dll
Secur32.dll loaded at 0x77fe0000
No symbols available from COMCTL32.dll
COMCTL32.dll loaded at 0x773d0000
No symbols available from msvcrt.dll
msvcrt.dll loaded at 0x77c10000
No symbols available from SHLWAPI.dll
SHLWAPI.dll loaded at 0x77f60000
No symbols available from MSIMG32.dll
MSIMG32.dll loaded at 0x76380000
No symbols available from ole32.dll
ole32.dll loaded at 0x774e0000
No symbols available from OLEACC.dll
OLEACC.dll loaded at 0x74c80000
No symbols available from MSVCP60.dll
MSVCP60.dll loaded at 0x76080000
No symbols available from OLEAUT32.dll
OLEAUT32.dll loaded at 0x77120000
No symbols available from USP10.dll
USP10.dll loaded at 0x74d90000
No symbols available from comdlg32.dll
comdlg32.dll loaded at 0x763b0000
No symbols available from SHELL32.dll
SHELL32.dll loaded at 0x7c9c0000
Unknown breakpoint hit at ntdll.dll (0x7c901230) thread(4064)
No symbols available from IMM32.dll
IMM32.dll loaded at 0x76390000
No symbols available from LPK.dll
LPK.dll loaded at 0x629c0000
No symbols available from COMCTL32.dll
COMCTL32.dll loaded at 0x5d090000
No symbols available from UxTheme.dll
UxTheme.dll loaded at 0x5ad70000
No symbols available from gdiplus.dll
gdiplus.dll loaded at 0x4ec50000
Unhandled D Exception (tango.core.Exception.IllegalArgumentException
 "Argument cannot be null") at KERNEL32.dll (0x7c812a5b) thread(4064)

tested with dwt-win svn, dwt-addons svn, tango svn, dmd 1.028

05/19/08 07:54:07 changed by yidabu

i tried the ActionAndStatusBar? example, ddbg output:

->r
No symbols available from ntdll.dll
ntdll.dll loaded at 0x7c900000
No symbols available from KERNEL32.dll
KERNEL32.dll loaded at 0x7c800000
No symbols available from USER32.dll
USER32.dll loaded at 0x7e410000
No symbols available from GDI32.dll
GDI32.dll loaded at 0x77f10000
No symbols available from ADVAPI32.dll
ADVAPI32.dll loaded at 0x77dd0000
No symbols available from RPCRT4.dll
RPCRT4.dll loaded at 0x77e70000
No symbols available from Secur32.dll
Secur32.dll loaded at 0x77fe0000
No symbols available from COMCTL32.dll
COMCTL32.dll loaded at 0x773d0000
No symbols available from msvcrt.dll
msvcrt.dll loaded at 0x77c10000
No symbols available from SHLWAPI.dll
SHLWAPI.dll loaded at 0x77f60000
No symbols available from MSIMG32.dll
MSIMG32.dll loaded at 0x76380000
No symbols available from ole32.dll
ole32.dll loaded at 0x774e0000
No symbols available from OLEACC.dll
OLEACC.dll loaded at 0x74c80000
No symbols available from MSVCP60.dll
MSVCP60.dll loaded at 0x76080000
No symbols available from OLEAUT32.dll
OLEAUT32.dll loaded at 0x77120000
No symbols available from USP10.dll
USP10.dll loaded at 0x74d90000
No symbols available from comdlg32.dll
comdlg32.dll loaded at 0x763b0000
No symbols available from SHELL32.dll
SHELL32.dll loaded at 0x7c9c0000
Unknown breakpoint hit at ntdll.dll (0x7c901230) thread(3424)
No symbols available from IMM32.dll
IMM32.dll loaded at 0x76390000
No symbols available from LPK.dll
LPK.dll loaded at 0x629c0000
No symbols available from COMCTL32.dll
COMCTL32.dll loaded at 0x5d090000
No symbols available from UxTheme.dll
UxTheme.dll loaded at 0x5ad70000
No symbols available from gdiplus.dll
gdiplus.dll loaded at 0x4ec50000
Unhandled D Exception (tango.core.Exception.IllegalElementException
 "Attempt to include invalid key _in Collection") at KERNEL32.dll (0x7c812a5b) t
hread(3424)

05/19/08 07:59:24 changed by yidabu

Heres the stacktrace of ActionAndStatusBar?.exe ->us #0 ?? () from KERNEL32.dll #1 0x0040a9e0 in d_throw@4 () from deh #2 0x004a3f57 in class dwtx.jface.resource.ResourceManager?.ResourceManager?.ano nclass450._ctor dwtx.jface.resource.JFaceResources.JFaceResources.getResources(c lass dwt.widgets.Display.Display) . class dwtx.jface.resource.JFaceResources.JFa ceResources.getResources function(class dwt.widgets.Display.Display, void*) . cl ass dwtx.jface.resource.ResourceManager?.ResourceManager?.anonclass450 function( class dwt.widgets.Display.Display) () from JFaceResources #3 0x004a3ef8 in class dwtx.jface.resource.ResourceManager?.ResourceManager? dwtx. jface.resource.JFaceResources.JFaceResources.getResources(class dwt.widgets.Disp lay.Display) () from JFaceResources #4 0x004a401c in class dwtx.jface.resource.ImageRegistry?.ImageRegistry? dwtx.jfac e.resource.JFaceResources.JFaceResources.getImageRegistry() () from JFaceResourc es #5 0x006f8e28 in void dwtx.jface.fieldassist.FieldDecorationRegistry?.FieldDecora? tionRegistry._staticCtor23() () from FieldDecorationRegistry? ->

05/19/08 08:19:46 changed by yidabu

statcktrace for the code above:

->us
#0 ?? () from KERNEL32.dll
#1 0x00406f0c in __d_throw@4 () from deh
#2 0x00ebb732 in void dwt.DWT.DWT.error(int, class Exception) () from DWT
#3 0x00ef81d9 in class dwt.graphics.GC.GC dwt.graphics.GC.GC._ctor(class dwt.gra
phics.Drawable.Drawable, void*) () from GC
#4 0x00e3d836 in void dwtx.jface.layout.LayoutConstants.LayoutConstants.initiali
zeConstants() () from LayoutConstants
#5 0x00e3d909 in class dwt.graphics.Point.Point dwtx.jface.layout.LayoutConstant
s.LayoutConstants.getSpacing() () from LayoutConstants

05/21/08 00:32:25 changed by keinfarbton

Arghhhh..

I don't know how, but i completely missed the IMPORTANT part with building dwtx as a lib.

Sorry

Now i see the problem. But i don't know a solution yet.

05/21/08 22:07:40 changed by keinfarbton

  • status changed from new to closed.
  • resolution set to fixed.

In DSSS i suggest to do oneatatime=no to get better compiler times. (20 min vs 20 sec). Using the dwtx lib shows why Gregor did oneatatime=yes by default. There are weird things going on if oneatatime=no is used to build libs. With only the dwt lib it seems to work fine. Using both produces the crashes you encountered.

To test this, I did set back oneatatime=yes and made a -full build of both libs. On my machine each about 20 minutes. Then i build all jface examples and they worked fine.

I close this ticket, if you still have problems please reopen.